var meta = document.createElement('meta');
meta.setAttribute('name', 'viewport');
meta.setAttribute('content', 'width=device-width,initial-scale=1,user-scalable=no');
document.getElementsByTagName('head')[0].appendChild(meta);

function disableInput() {
    var inputArr = document.getElementsByTagName("input");
    var i;
    for (i = 0; i < inputArr.length; i ++){
        var item = inputArr[i];
        item.setAttribute('readonly', 'readonly');
    }
    var arr = document.getElementsByClassName('quizPutTag');
    var i;
    for (i = 0; i < arr.length; i ++){
        var item = arr[i];
        item.removeAttribute('contenteditable');
    }
}

function addQuestions(questions) {
    var content = document.getElementById("content");
    var index = content.children.length;
    for (var i = 0; i < questions.length; i ++){
        var html = "";
        var question = questions[i];
        var itemElement = document.createElement("div");
        if(i == questions.length - 1){
            itemElement.setAttribute("class", "echo-item");
        }else{
            itemElement.setAttribute("class", "echo-item item-border");
        }
        var questionElement  = document.createElement("div");
        questionElement.setAttribute("class", "echo-question");
        questionElement.setAttribute("onclick", "showDetail(" + (i + index) + ")");
        itemElement.appendChild(questionElement);
        var stemElement  = document.createElement("div");
        stemElement.setAttribute("class", "echo-title");
        stemElement.innerHTML = (i + index + 1) + '、' + question['stem'];
        questionElement.appendChild(stemElement);
        var optionsElement = document.createElement("div");
        optionsElement.setAttribute("class", "echo-options");
        questionElement.appendChild(optionsElement);
        var options = question['options'];
        for (var j = 0; j < options.length; j ++) {
            var option = options[j];
            var letter = String.fromCharCode(0x60+1 + j).toUpperCase();
            var optionElement = document.createElement("div");
            optionElement.setAttribute("class", "echo-option");
            optionsElement.appendChild(optionElement);
            var optionflagElement = document.createElement("div");
            optionflagElement.innerHTML = letter;
            optionElement.appendChild(optionflagElement);
            var optiondescElement = document.createElement("div");
            optiondescElement.setAttribute("class", "option-desc");
            optiondescElement.innerHTML = option;
            optionElement.appendChild(optiondescElement);
            var studentAnswer = question['studentAnswer'];
            if (studentAnswer != null){
                var answers = question["answer"];
                var in_arr2 = studentAnswer.in_array(j);
                var in_arr1 = false;
                if(answers != null){
                    in_arr1 = answers.in_array(j);
                }
                if (in_arr1){
                    optionflagElement.setAttribute("class", "option-flag-right");
                }else {
                    if(in_arr2){
                        optionflagElement.setAttribute("class", "option-flag-wrong");
                    }else {
                        optionflagElement.setAttribute("class", "option-flag-empty");
                    }
                }
            }else{
                var answers = question["answer"];
                var in_arr2 = false;
                if(answers != null){
                    in_arr2 = answers.in_array(j);
                }
                if(in_arr2){
                    optionflagElement.setAttribute("class", "option-flag-right");
                }else {
                    optionflagElement.setAttribute("class", "option-flag-empty");
                }
            }
        }
        var tagsElement  = document.createElement("div");
        tagsElement.setAttribute("class", "echo-tags");
        questionElement.appendChild(tagsElement);
        var remark = question['remark'];
        if(remark != null && remark != ''){
            var tagrateElement  = document.createElement("div");
            tagrateElement.setAttribute("class", "echo-tag tag-remark");
            tagrateElement.innerHTML = '笔记';
            tagsElement.appendChild(tagrateElement);
        }
        var taglevelElement  = document.createElement("div");
        taglevelElement.setAttribute("class", "echo-tag tag-level");
        taglevelElement.innerHTML = question['difficultyTypeName'];
        tagsElement.appendChild(taglevelElement);
        var time = question['time'];
        if(time != null){
            var timeElement  = document.createElement("div");
            timeElement.setAttribute("class", "question-time");
            timeElement.innerHTML = "<img src = file:///android_res/mipmap/icon_alarm.png>" + '<span>&nbsp' + time + "</span>";
            tagsElement.appendChild(timeElement);
        }
        var actionBtnElement  = document.createElement("div");
        actionBtnElement.setAttribute("class", "practice-btn");
        actionBtnElement.setAttribute("onclick", "practiceQuestionAtIndex(" + (i + index) + ")");
        actionBtnElement.innerHTML = '巩固此题';
        itemElement.appendChild(actionBtnElement);
        document.getElementById("content").appendChild(itemElement);
    }
    disableInput();
}

function resetQuestions(questions) {
    var content = document.getElementById("content");
    var children = content.children;
    for (var i = children.length - 1; i >= 0; i --) {
        var item = content.children.item(i);
        content.removeChild(item);
    }
    addQuestions(questions);
}

function practiceQuestionAtIndex(index){
    var msg = {index:index, action:'practice'};
    window.QuestionHandler.postMessage(JSON.stringify(msg));
}

function showDetail(index) {
    var msg = {index:index, action:'showDetail'};
    window.QuestionHandler.postMessage(JSON.stringify(msg));
}

Array.prototype.in_array = function (e) {
    var r=new RegExp(','+e+',');
    return (r.test(',' + this.join(this.S) + ','));
}
